#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "tabledist.h"

/* Number of values generated to determine the stats (way higher than needed) */
#define NVALUES 10000

void arraystats(double *x, int limit, double *mu, double *sigma, double *rho);

int
main(int argc, char **argv)
{
	double mu, sigma, corr;
	double actualmu, actualsigma, actualcorr;
	int value;
	InternalStats stats;
	int i;
	double values[NVALUES];

	mu = 500.0;
	sigma = 10.0;

printf(
"/* This is the sigma \"correction\" table, indexed by rho at every\n"
" * .01 from -1.0 to .99.  (Far more precision than really required...)\n"
" * This is the table for the %s distribution.  You could actually\n"
" * just use this one for all of them (they're all quite close), but\n"
" * I guess I'll make separate tables for each.\n"
" */\n"
"/* To determine correction:\n"
" *	index = rint((rho+1)*100)\n"
" * We use linear interpolation between entries...\n"
" */\n"
"#define RHO_INDEX 100.0\n"
"#define RHO_INDEX_LIMIT	200\n"
"\n"
"double rhosigmacorrect[] = {\n"
, DISTRIBUTION_NAME
);

	for (corr = -1.0; corr <= .991; corr += .01) {
		MakeDistributedStats(mu, sigma, corr, &stats);

		for (i=0; i < NVALUES; ++i) {
			if (stats.intrho) {
				value = correlatedtabledist(&stats);
			}
			else
				value = tabledist(stats.intmu, stats.intsigma);
			values[i] = (double)value;
		}
		arraystats(values, NVALUES, &actualmu, &actualsigma, &actualcorr);
		/*printf("mu %10.4f sigma %10.4f corr %10.4f\n",
			actualmu, actualsigma, actualcorr);*/
		printf("%10.4f,\n", actualsigma/sigma);
	}
printf("%s",
"};\n"
);
	return 0;
}

